import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsTeacherinfo {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  TeacherId!: IType<number, bigint>;
  TeacherName?: string;
  TeacherLevel!: number;
  Tag?: string;
  Profile?: unknown;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsTeacherinfoSchema = defineEntity({
  class: ScsTeacherinfo,
  comment: '教师信息',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    TeacherId: p.bigint().name('TeacherId').columnType('bigint').comment('教师id').unique('idx_SCS_TeacherInfo_01'),
    TeacherName: p.string().name('TeacherName').nullable().comment('教师姓名'),
    TeacherLevel: p.integer().name('TeacherLevel').comment('名师级别'),
    Tag: p.string().name('Tag').nullable().comment('教师标签'),
    Profile: p.array().name('Profile').length(16777215).nullable().comment('教师简介'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
